// Set options as a parameter, environment variable, or rc file.
// eslint-disable-next-line no-global-assign
require = require("esm")(module/* , options */);
//Set defaults
global.Promise = require("bluebird");
//
module.exports = {
  //Base Events
  IKTransaction: require("./src/BaseEvent/IKTransaction.js").default,
  IKProcess: require("./src/BaseEvent/IKProcess.js").default,
  //Extra Events
  IKRouter: require("./src/IKRouter.js").default,
  IKEventProcessor: require('./src/IKEventProcessor.js').default,
  IKDynamoStream: require('./src/IKDynamoStream.js').default,
  IKStepTransaction: require('./src/IKStepTransaction.js').default,

  //Extra components
  IKMailer: require('./src/Mailer/IKMailer.js').default,
  IKValidation: require('./src/Validation/IKValidation.js').default,

  //Responses
  IKResponse: require("./src/API/IKResponse.js").default,
  IKBadRequestResponse: require("./src/API/IKResponse.js").IKBadRequestResponse,
  IKUnauthorizedResponse: require("./src/API/IKResponse.js").IKUnauthorizedResponse,
  IKMissingParamResponse: require("./src/API/IKResponse.js").IKMissingParamResponse,
  IKMissingQueryResponse: require("./src/API/IKResponse.js").IKMissingQueryResponse,
  IKSuccessResponse: require("./src/API/IKResponse.js").IKSuccessResponse,
  IKSuccessStreamResponse: require("./src/API/IKResponse.js").IKSuccessStreamResponse,
  IKSuccessNoContentResponse: require("./src/API/IKResponse.js").IKSuccessNoContentResponse,
  IKBadRequestResponseWithRollback: require("./src/API/IKResponse.js").IKBadRequestResponseWithRollback,
  IKStepFunctionResponse: require("./src/API/IKResponse.js").IKStepFunctionResponse,
  IKSimpleResponse: require("./src/API/IKResponse.js").IKSimpleResponse,
  
  //Helpers
  Utils: require("./src/API/IKUtils.js").default,

  //Cache
    //Redis
      IKRedis: require('./src/Cache/Redis/IKRedis').default,

  //Database
    //PSQL
      IKDBPSQLQuery: require("./src/Database/PSQL/IKDBBaseQuery.js").default,
    //DDB
      IKDBDDBQueryScan: require("./src/Database/DDB/IKDBQueryScan.js").default,
      IKDBDDBQueryGet: require("./src/Database/DDB/IKDBQueryGet.js").default,
      IKDBDDBQueryPut: require("./src/Database/DDB/IKDBQueryPut.js").default,
      IKDBDDBQueryUpdate: require("./src/Database/DDB/IKDBQueryUpdate.js").default,
      IKDBDDBQueryDelete: require("./src/Database/DDB/IKDBQueryDelete.js").default,
      IKDBDDBQueryBatchWrite: require("./src/Database/DDB/IKDBQueryBatchWrite.js").default,
      IKDBDDBQueryTransactionalWrite: require("./src/Database/DDB/IKDBQueryTransactionalWrite.js").default,
      IKDBDDBExpressionOperator: require("./src/Database/DDB/IKDBBaseExpression.js").IKDBExpressionOperator,
    //Legacy
      IKDBQueryScan: require("./src/Database/DDB/IKDBQueryScan.js").default,
      IKDBQueryGet: require("./src/Database/DDB/IKDBQueryGet.js").default,
      IKDBQueryPut: require("./src/Database/DDB/IKDBQueryPut.js").default,
      IKDBQueryUpdate: require("./src/Database/DDB/IKDBQueryUpdate.js").default,
      IKDBQueryDelete: require("./src/Database/DDB/IKDBQueryDelete.js").default,
      IKDBQueryBatchWrite: require("./src/Database/DDB/IKDBQueryBatchWrite.js").default,
      IKDBQueryTransactionalWrite: require("./src/Database/DDB/IKDBQueryTransactionalWrite.js").default,
      IKDBExpressionOperator: require("./src/Database/DDB/IKDBBaseExpression.js").IKDBExpressionOperator,
};
