import IKDBBaseQuery from './IKDBBaseQuery';
import Utils from './../../API/IKUtils';
//
export default class IKDBQueryUpdate extends IKDBBaseQuery {
  constructor(indexName) {
    super(indexName)
  }
  //
  async run(dbManager) {
    const resp = await this.rawRun(dbManager);
    const unmarshalled = Utils.decapsulateForDB(resp.Items);
    const localConsole = (dbManager.transaction ? dbManager.transaction.logger : console);
    localConsole.log('Parsed result: ', unmarshalled);
    return unmarshalled;
  }
  async rawRun(dbManager) {
    let query = this._rawQuery(dbManager.tableName);
    const localConsole = (dbManager.transaction ? dbManager.transaction.logger : console);
    localConsole.log("Deleting item: ", query);
    let resp = await dbManager.connection.deleteItem(query);
    // localConsole.debug('Raw result: ', resp);
    this._incrementTrackerStats(resp, dbManager);
    return resp;
  }

  _rawQuery(dbTableName, isTransaction) {
    return { ...super._rawQuery(dbTableName, isTransaction),
             ...(isTransaction ? {} : {ReturnValues: "ALL_OLD" /*request all deleted values*/ })};
  }
  /* tracker support */
  _incrementTrackerStats(resp, dbManager) {
    if (resp && resp.ConsumedCapacity && resp.ConsumedCapacity.CapacityUnits) dbManager.stats.writeUnits += parseFloat(resp.ConsumedCapacity.CapacityUnits);
  }
}
