import IKDBBaseQuery from './../Prototype/IKDBBaseQuery';
//
export default class IKDBPSQLBaseQuery extends IKDBBaseQuery {
  constructor(query, params) {
    super();
    this.query = query;
    this.params = params;
  }
  async run(connection) {
    try {
      const resp = await this.rawRun(this.query, this.params, connection);
      return {error: null, data: resp};
    } catch (e) {
      const localConsole = (connection.transaction ? connection.transaction.logger : console);
      localConsole.error('Query Error:',e);
      return {error: e.toString().replace('Error:','').replace('Error:',''), data: []};
    }
  }
  async rawRun(query, params, connection) {
    const localConsole = (connection.transaction ? connection.transaction.logger : console);
    localConsole.debug('Querying: ', query, params);
    const resp = await connection.query(query, params)
    // console.debug('Raw result: ', resp);
    return resp;
  }
}
